<?php

$no_http_headers = true;
include(dirname(__FILE__) . "/../include/config.php");
include(dirname(__FILE__) . "/../lib/snmp.php");

  //"index"     => ".1.3.6.1.3.94.1.10.1.2.16.0.0.13.236.25.209.127.0.0.0.0.0.0.0.0",
// Array that supports index operation
$oids = array(
  "index"     => ".1.3.6.1.3.94.1.10.1.2",
  "name"      => ".1.3.6.1.3.94.1.10.1.17",
  "speed"     => ".1.3.6.1.3.94.1.10.1.15",
  "errors"    => ".1.3.6.1.3.94.4.5.1.3",
  "txelement" => ".1.3.6.1.3.94.4.5.1.6",
  "rxelement" => ".1.3.6.1.3.94.4.5.1.7",
  "1rxframe"  => ".1.3.6.1.3.94.4.5.1.14",
  "1txframe"  => ".1.3.6.1.3.94.4.5.1.15",
  "2rxframe"  => ".1.3.6.1.3.94.4.5.1.20",
  "2txframe"  => ".1.3.6.1.3.94.4.5.1.21",
  "3rxframe"  => ".1.3.6.1.3.94.4.5.1.26",
  "3txframe"  => ".1.3.6.1.3.94.4.5.1.27",
  "3discard"  => ".1.3.6.1.3.94.4.5.1.28",
  "rxlreset"  => ".1.3.6.1.3.94.4.5.1.33",
  "txlreset"  => ".1.3.6.1.3.94.4.5.1.34",
  "linkfail"  => ".1.3.6.1.3.94.4.5.1.39",
  "intxword"  => ".1.3.6.1.3.94.4.5.1.41",
  "syncloss"  => ".1.3.6.1.3.94.4.5.1.44"
	);

$hostname = $_SERVER["argv"][1];
$snmp_community = $_SERVER["argv"][2];
$snmp_version = $_SERVER["argv"][3];
$cmd = $_SERVER["argv"][4];
print "Host = " . $hostname . " Community = " . $snmp_community . " Command = " .$cmd . "\n";

if ($cmd == "index") 
{
	$return_arr = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["index"], $snmp_version, "", ""));
	
	for ($i=0;($i<sizeof($return_arr));$i++) 
  {
		print $i+1 . "\n";
	}
}elseif ($cmd == "query") {
	$arg = $_SERVER["argv"][5];

	$arr_index = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["index"], $snmp_version, "", ""));
	$arr = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids[$arg], $snmp_version, "", ""));
	
	for ($i=0;($i<sizeof($arr_index));$i++) 
  {
    $convert_hex = hex2dec($arr[$i]);
		print $arr_index[$i] . "!" . $convert_hex . "\n";
	}
}elseif ($cmd == "get") {
	$arg = $_SERVER["argv"][5];
	$index = $_SERVER["argv"][6];
	
	// Its a pain in the ass, but the fiber Channel SNMP OIDS have a small difference on each device.
	// Only an SNMP walk can find the correct oid and the correct value
	$arr_index = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["index"], $snmp_version, "", ""));
	$arr = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids[$arg], $snmp_version, "", ""));
	
	// Use "index-1" to find correct value, Array starts at 0, not 1
  $convert_hex = hex2dec($arr[$index-1]);
	
	print "$convert_hex";
}

function reindex($arr) 
{
	$return_arr = array();
	for ($i=0;($i<sizeof($arr));$i++) 
  {
		$return_arr[$i] = $arr[$i]["value"];
	}
	
	return $return_arr;
}

function hex2dec($output)
{ $hex = '';
  $dec = 0;
  $ishex = substr($output,0,3);
  $i = 0;
  if ($ishex == 'HEX')
  { $i = $i + 1;
    $len = strlen($output);
    $hexstr = substr($output,4,$len);
    $charpos = strpos($hexstr,':');
    $hex = substr($hexstr,0,2);
    $hexlen = strlen($hexstr);
    $hexstr = substr($hexstr,$charpos+1,$hexlen);
    $charpos = strpos($hexstr,':');
    while($charpos <> false)
    { $charpos = strpos($hexstr,':');
      $hex = $hex . substr($hexstr,0,2);
      $hexlen = strlen($hexstr);
      $hexstr = substr($hexstr,$charpos+1,$hexlen);
      $i = $i + 1;
    }
    $dec = hexdec($hex);
  }
  else
  { $dec = $output;
  }
  return $dec;
}

?>
